define(function( require ){

	const jQuery        = require( 'jquery' );
	const taffy_loader  = require( 'TAFFY' );
	const Mustache      = require( 'mustache' );

	return function( s ){



		/*
			N O D E S
		 */
		let target_node    = {};
		let template_node  = {};


		/*
			P R I V A T E   V A R S
		 */
		let template_string   = "";
		let posts       = [];


		/*
			I N I T
		 */

		init( s );

		/*
			E V E N T S
		 */

		window.addEventListener('hashchange', function() {
			render_events();
		}, false);


		/*
			M E T H O D S
		 */
		 function init( s ){
 			update( s );
 		}

 		function update( s ){
 			target_node     = jQuery( s.target_selector );
 			template_node   = jQuery( s.template_selector  );
 			posts           = TAFFY( s.posts );
 			template_string = template_node.html();

 			render_events();
 		}

		function render_events(){
			target_node.empty();
			let selector = get_filter(); // { "eventtyp":{'has':[]}, "zielgruppe":{'has':[]} }

			if( window.event_distance ){
				selector.zipcode = { 'is':window.event_distance };

			}

			posts( selector ).each( function (r) {
				target_node.append( Mustache.render( template_string, r ) );
			})
		}

		function get_filter(){
			let taffy_selector = {};
			let encoded_string = location.hash.substr(1);
			let json_string    = decodeURI( encoded_string );
			let filter_json    = ( json_string.length ) ? JSON.parse( json_string ) : {};

			for ( let key in filter_json ) {
				taffy_selector[key] = { 'has' : filter_json[key] }
			}

			return taffy_selector;
		}

		return{
			init : init,
		}
	}
})
