define( function( require ){

	const jQuery       = require( 'jquery' );
	const jQuery_clndr = require( 'jquery-clndr' );
	const moment       = require( 'moment' );
	const Mustache     = require( 'mustache' );

	return function( s ){

		/*
			N O D E S
		 */
		let kalender_node  = {};
		let template_node  = {};

		/*
			P R I V A T E   V A R S
		 */
		let template_string   = "";
		let events_list       = [];
		let events_dummy_list = [
			{ start: '2019-04-05', end: '2019-04-09', title: 'Ein Test Event', copy:"1 - Lorem ipsum dolor sit amet, consetetur sadipscing elitr", url: 'http://github.com/kylestetz/CLNDR' },
			{ start: '2019-05-01', end: '2019-05-01', title: 'Tag der Arbeit, trotzdem Frei', copy:"2 - Lorem ipsum dolor sit amet, consetetur sadipscing elitr", url: 'http://github.com/kylestetz/CLNDR' },
			{ start: '2019-05-12', end: '2019-05-14', title: 'Dummy Event, Multi-Day', copy:"3 - Lorem ipsum dolor sit amet, consetetur sadipscing elitr", url: 'http://github.com/kylestetz/CLNDR' },
		];

		/*
			I N I T
		 */

		init( s );

		/*
			M E T H O D S
		 */
		function init( s ){
			update( s );
		}

		function update( s ){
			kalender_node   = jQuery( s.target_selector );
			template_node   = jQuery( s.template_selector  );
			events_list     = s.event_list;
			template_string = template_node.html();

			render_calendar();
		}


		function render_calendar(){
			if( kalender_node.length ) {

				moment.locale( 'de' );

				jQuery('#KalenderEvents').clndr({
					weekOffset     : 0,
					startWithMonth : moment(),
					daysOfTheWeek  : ['Mo', 'Di', 'Mi', 'Do', 'Fr', 'Sa', 'So'],
					events         : events_list, //events_list.concat(events_dummy_list),
					multiDayEvents: {
						startDate : 'start',
						endDate   : 'end'
					},
					targets: {
						nextButton     : 'action-next-month',
						previousButton : 'action-prev-month',
						//todayButton    : 'clndr-today-button',
						//day            : 'day',
						//empty          : 'empty'
					},
					render : function(data){
						return Mustache.render( template_string, data );
					}
				});
			};
		}

		return {
			update : update,
		}
	}
})
